//
//  CheckYueYuTool.m
//  SafeToolTest
//
//  Created by 张国礼 on 2022/11/8.
//
#include <sys/stat.h>
#import "ZhiYuan_CheckYueYuTool.h"
#include <sys/stat.h>
#include <dlfcn.h>


@implementation ZhiYuan_CheckYueYuTool

//判断⼯具安装路径本期先做成BOOL开关⽅法
//下面路径也可替换为以下常见⼯具路径：
// /Library/MobileSubstrate/MobileSubstrate.dylib
///Applications/Cydia.app   /var/lib/cydia/
///var/cache/apt   /var/lib/apt    /etc/apt
///bin/bash /bin/sh
///usr/sbin/sshd   /usr/libexec/ssh-keysign   /etc/ssh/sshd_config
+ (BOOL)zhiyuan_checkPath
{
    BOOL jailBroken = NO;
    NSString * cydiaPath = @"/Applications/Cydia.app";
    NSString * aptPath = @"/private/var/lib/apt";
    if ([[NSFileManager defaultManager] fileExistsAtPath:cydiaPath]) {
        jailBroken = YES;
    }
    if ([[NSFileManager defaultManager] fileExistsAtPath:aptPath]) {
        jailBroken = YES;
    }
    return jailBroken;
}


//防hook NSFileManager的⽅法使⽤stat系列函数检测Cydia等⼯具，路径同上
+ (BOOL)zhiyuan_checkCydia
{
    struct stat stat_info;
    if (0 == stat("/Applications/Cydia.app", &stat_info)) {
        NSLog(@"Device is jailbroken");
        return YES;
    }
    return NO;
}



//检测当前程序运⾏的环境变量，防⽌通过DYLD_INSERT_LIBRARIES注⼊链接异常动态库，来更改相关⼯具名称
+ (BOOL)zhiyuan_checkEnv
{
    char *env = getenv("DYLD_INSERT_LIBRARIES");
    NSLog(@"%s", env);
    if (env) {
        return NO;
    }
    return NO;
}


+ (BOOL)zhiyuan_isStatNotSystemLib {
    
    if(TARGET_IPHONE_SIMULATOR)return NO;
    
    int ret ;
    
    Dl_info dylib_info;
    
    int (*func_stat)(const char *, struct stat *) = stat;
    
    if ((ret = dladdr(&func_stat, &dylib_info))) {
        
        NSString *fName = [NSString stringWithUTF8String: dylib_info.dli_fname];
        
        if(![fName isEqualToString:@"/usr/lib/system/libsystem_kernel.dylib"]){
            
            return YES;
            
        }
        
    }
    return NO;
}


+ (BOOL)zhiyuan_isBeiYueYu
{
    
    BOOL ret = NO;
    if ([ZhiYuan_CheckYueYuTool zhiyuan_checkPath] || [ZhiYuan_CheckYueYuTool zhiyuan_checkEnv] || [ZhiYuan_CheckYueYuTool zhiyuan_isStatNotSystemLib] || [ZhiYuan_CheckYueYuTool zhiyuan_checkCydia]) {
        
        ret =  YES;
    }
    
    return ret;
}


@end
