//
//  MyAdViewController.m
//  SafeToolTest
//
//  Created by 张国礼 on 2022/3/9.
//

#import "ZhiYuan_MyAdViewController.h"

@interface ZhiYuan_MyAdViewController ()

@property(nonatomic, strong) NSTimer  *zhiyuan_timer;
@property(nonatomic, strong) UIButton *zhiyuan_tiyanBtn;
@property(nonatomic, assign) BOOL     zhiyuan_isScale;

@end

@implementation ZhiYuan_MyAdViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    self.view.backgroundColor = [UIColor colorWithWhite:0 alpha:0];

    
    UIImageView *adBgImgView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"AdBg"]];
    [self.view addSubview:adBgImgView];
    adBgImgView.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:self.zhiyuan_jumpDict[@"jumpimgurl"]]]];
    adBgImgView.contentMode = UIViewContentModeScaleAspectFill;
    adBgImgView.layer.cornerRadius = 12;
    adBgImgView.clipsToBounds = YES;
    CGFloat screenWidth = [UIScreen mainScreen].bounds.size.width;
    CGFloat screenHeight = [UIScreen mainScreen].bounds.size.height;

    UIButton *tiyanBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [tiyanBtn setImage:[UIImage imageNamed:@"tiyanbtn"] forState:UIControlStateNormal];
    [self.view addSubview:tiyanBtn];
    [tiyanBtn addTarget:self action:@selector(tiyanBtnClicked) forControlEvents:UIControlEventTouchUpInside];
    self.zhiyuan_tiyanBtn = tiyanBtn;
    
    UIButton *closeMyAdBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [closeMyAdBtn setImage:[UIImage imageNamed:@"myCloseAd"] forState:UIControlStateNormal];
    [closeMyAdBtn addTarget:self action:@selector(closeMyAdBtnClicked) forControlEvents:UIControlEventTouchUpInside];

    
    if ([self.zhiyuan_jumpDict[@"jumpType"] integerValue] == 0) {
        
        CGFloat adImgViewWdith = screenWidth - 100;
        CGFloat adImgViewHeight = adImgViewWdith * 1.5;
        
        adBgImgView.frame = CGRectMake(50, (screenHeight-adImgViewHeight-40)/2, adImgViewWdith, adImgViewHeight);
        
        CGFloat tiyanBtnHeight = 46;
        CGFloat tiyanBtnWidth = screenWidth-80;
        
        tiyanBtn.frame = CGRectMake((screenWidth-tiyanBtnWidth)/2, CGRectGetMaxY(adBgImgView.frame)+50, tiyanBtnWidth, tiyanBtnHeight);
        closeMyAdBtn.frame = CGRectMake(CGRectGetMaxX(adBgImgView.frame)-50, CGRectGetMinY(adBgImgView.frame)+10, 40, 40);
        closeMyAdBtn.alpha = 0.8;
        
    }else if([self.zhiyuan_jumpDict[@"jumpType"] integerValue] == 1){
        
        CGFloat adImgViewWdith = screenWidth;
        CGFloat adImgViewHeight = screenHeight;
        
        adBgImgView.frame = CGRectMake(0, (screenHeight-adImgViewHeight)/2, adImgViewWdith, adImgViewHeight);
        
        CGFloat tiyanBtnHeight = 46;
        CGFloat tiyanBtnWidth = screenWidth-60;
        tiyanBtn.frame = CGRectMake((screenWidth-tiyanBtnWidth)/2, CGRectGetMaxY(adBgImgView.frame)-100, tiyanBtnWidth, tiyanBtnHeight);
        closeMyAdBtn.frame = CGRectMake(screenWidth-50, 50, 40, 40);
        closeMyAdBtn.alpha = 0.8;
        
    }
    
    [self.view addSubview:closeMyAdBtn];

}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    __block NSInteger isTimerOccur = 0;
    
    if ([self.zhiyuan_jumpDict[@"jumpauto"] integerValue] == 1) {
        _zhiyuan_timer = [NSTimer timerWithTimeInterval:0.3 repeats:YES block:^(NSTimer * _Nonnull timer) {
            self->_zhiyuan_isScale = !self->_zhiyuan_isScale;
            
            isTimerOccur+=1;
            
            if (isTimerOccur == 15) {
            
                [self tiyanBtnClicked];
            }
            
            if (!self->_zhiyuan_isScale) {
                self.zhiyuan_tiyanBtn.transform = CGAffineTransformScale(CGAffineTransformIdentity, 1.2, 1.2);
                
            }else{
                self.zhiyuan_tiyanBtn.transform = CGAffineTransformScale(CGAffineTransformIdentity, 1, 1);
            }
        }];
        
        [[NSRunLoop currentRunLoop] addTimer:_zhiyuan_timer forMode:NSRunLoopCommonModes];

    }

}


- (void)closeMyAdBtnClicked
{

    [_zhiyuan_timer invalidate];
    _zhiyuan_timer = nil;
    [self removeFromParentViewController];
    [self.view removeFromSuperview];
//    [self dismissViewControllerAnimated:NO completion:nil];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"ShowChaPingAd" object:nil];

}

//设置控制器透明
- (UIModalPresentationStyle)modalPresentationStyle {
    return UIModalPresentationOverCurrentContext;
}

//控制器弹出方式
- (UIModalTransitionStyle)modalTransitionStyle {
    return UIModalTransitionStyleCoverVertical;
}



- (void)tiyanBtnClicked
{
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:self.zhiyuan_jumpDict[@"url"]] options:@{} completionHandler:nil];
    [self dismissViewControllerAnimated:NO completion:nil];
}
@end
