import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'aorun_ad_platform_interface.dart';

/// An implementation of [AorunAdPlatform] that uses method channels.
class MethodChannelAorunAd extends AorunAdPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('aorun_ad');

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }

  @override
  Future<String?> showRewardVideoAd2() async{
    final result = (await methodChannel.invokeMethod<String>('showRewardVideoAd2'));
    return result;
  }

  @override
  Future<String?> showChaPingAd() async{
    final result = (await methodChannel.invokeMethod<String>('showChaPingAd'));
    return result;
  }
}
