import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'aorun_ad_method_channel.dart';

abstract class AorunAdPlatform extends PlatformInterface {
  /// Constructs a AorunAdPlatform.
  AorunAdPlatform() : super(token: _token);

  static final Object _token = Object();

  static AorunAdPlatform _instance = MethodChannelAorunAd();

  /// The default instance of [AorunAdPlatform] to use.
  ///
  /// Defaults to [MethodChannelAorunAd].
  static AorunAdPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [AorunAdPlatform] when
  /// they register themselves.
  static set instance(AorunAdPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?> showRewardVideoAd2() async{
    throw UnimplementedError('showRewardVideoAd2() has not been implemented.');
  }

  Future<String?> showChaPingAd() async{
    throw UnimplementedError('showChaPingAd() has not been implemented.');
  }
}
